#include <extdll.h>
#include <meta_api.h>
#include "plugin.h"
#include "engine.h"
#include "vers_plugin.h"

//#include <sdk_util.h>		// REG_SVR_COMMAND, etc

#define COMPILE_TIME (const char *)(__DATE__ ", " __TIME__)

// Must provide at least one of these..
META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI			HL SDK;		called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META;		called after game DLL
	GetEntityAPI2,		// pfnGetEntityAPI2			HL SDK2;	called before game DLL
	NULL,			// pfnGetEntityAPI2_Post		META;		called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2;	called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post		META;		called after game DLL
	GetEngineFunctions,	// pfnGetEngineFunctions		META;		called before HL engine
	NULL,			// pfnGetEngineFunctions_Post		META;		called after HL engine
};

cvar_t wre_multiplier	= {"wrecoil_multiplier","1", FCVAR_EXTDLL, 0, NULL};
cvar_t wre_debug	= {"wrecoil_debug","0", FCVAR_EXTDLL, 0, NULL};
cvar_t wre_ver 		= {"wrecoil_version",VVERSION, FCVAR_EXTDLL|FCVAR_SERVER, 0, NULL};

extern cvar_t *wrecoil_multiplier;
extern cvar_t *wrecoil_debug;

extern player_t players[32];

// Plugin startup.  Register commands and cvars.
void plugin_init(void) {
	LOG_MESSAGE(PLID, "%s v%s, %s", Plugin_info.name, Plugin_info.version, Plugin_info.date);
	LOG_MESSAGE(PLID, "by %s", Plugin_info.author);
	LOG_MESSAGE(PLID, "   %s", Plugin_info.url);
	LOG_MESSAGE(PLID, "compiled: %s EET", COMPILE_TIME);
	
	CVAR_REGISTER(&wre_multiplier);
	CVAR_REGISTER(&wre_debug);
	CVAR_REGISTER(&wre_ver);
	
	wrecoil_multiplier	= CVAR_GET_POINTER(wre_multiplier.name);
	wrecoil_debug		= CVAR_GET_POINTER(wre_debug.name);
}

