#include <extdll.h>
#include "sdk_util.h"
#include "engine.h"
#include <dllapi.h>
#include <meta_api.h>
#include "vector.h"
#include "userid_list.h"

#define IsValidIndex(index) ( index > 0 && index <= gpGlobals->maxClients )
#define UTIL_MakeVectors(vecAngles) MAKE_VECTORS( vecAngles )

cvar_t *wrecoil_multiplier;
cvar_t *wrecoil_debug;
float RecoilTableAmmo1[64];
float RecoilTableAmmo2[64];

inline void SetRecoil( Vector vecAiming, float Recoil, edict_t *ed)
{
	if (Recoil==0 || vecAiming.Length()==0) 
	{
		return;
	}
	
	ed->v.velocity = ed->v.velocity - vecAiming * Recoil;
}

inline void MakeRecoil(int WeaponID , edict_t *ed, int ammo, float multi,int ammotype)
{
	if (ed==NULL || ed->v.health<=0 || ed->v.deadflag!=DEAD_NO || multi==0) return;
	if (multi<0 || multi>10) multi=1.0;
	
	UTIL_MakeVectors( ed->v.v_angle + ed->v.punchangle );

	float Recoil=(float)(((ammotype==1) ? RecoilTableAmmo1[WeaponID] : RecoilTableAmmo2[WeaponID]) * ammo);

	if (wrecoil_debug->value>0) ALERT(at_console,"{[Recoil]} ammo:%d multi:%f ammotype:%s --> Recoil:%f\n",ammo,multi,((ammotype==1) ? "AMMO1" : "AMMO2" ),Recoil);

	SetRecoil(gpGlobals->v_forward,(Recoil*multi),ed);
}

void LoadINIData();

extern char		*mod_dir;

// message created in RegUserMsg which will be "caught"
int message_CurWeapon	=	0;
int message_AmmoX	=	0;
int message_WeaponList	=	0;

int cap_msg_type	=	0;
int capturemode		=	FALSE;
int capturecounter	=	0;
int player_index	=	0;
edict_t *pPlayer	=	NULL;
int AmmoDetectAsFlag	=	FALSE;
int AllWeaponsClipless	=	FALSE;

player_weapon_t weapon_defs[MAX_WEAPONS];
player_t players[32];

void pfnMessageBegin(int msg_dest, int msg_type, const float *pOrigin, edict_t *pEdict)
{
	if (!gpGlobals->deathmatch || !pEdict) RETURN_META(MRES_IGNORED);

//	int eindex = ENTINDEX(pEdict);
	int index = GETPLAYERUSERID(pEdict);

	// is this message for a player and alive?
	if (index!=-1)// && IsValidIndex(eindex))
	{
		if (pEdict->v.spawnflags & SF_PLAYER_DISCONNECTED1 && pEdict->v.spawnflags & SF_PLAYER_DISCONNECTED2)
			goto Taktinen1;

		if (message_CurWeapon == 0) message_CurWeapon = GET_USER_MSG_ID(PLID,"CurWeapon",NULL);
		if (message_AmmoX     == 0) message_AmmoX     = GET_USER_MSG_ID(PLID,"AmmoX",NULL);
		if (message_WeaponList== 0) message_WeaponList= GET_USER_MSG_ID(PLID,"WeaponList",NULL);
		
		if (wrecoil_debug->value>1)
		{
			if (msg_type==message_CurWeapon)
			{
				ALERT(at_console,"[[CurWeapon]] [player-id:%d]\n",index-1);
			}
			else if (msg_type==message_AmmoX)
			{
				ALERT(at_console,"[[AmmoX]] [player-id:%d]\n",index-1);
			}
			else if (msg_type==message_WeaponList)
			{
				ALERT(at_console,"[[WeaponList]] [player-id:%d]\n",index-1);
			}
		}

		if (msg_type!=message_CurWeapon && msg_type!=message_AmmoX && msg_type!=message_WeaponList)
		{
Taktinen1:
			cap_msg_type	= 0;
			capturemode	= FALSE;
			capturecounter	= 0;
			player_index	= 0;
			pPlayer		= NULL;
				
			RETURN_META(MRES_IGNORED);
		}
			
		cap_msg_type	= msg_type;
		capturemode	= TRUE;
		capturecounter	= 0;
		player_index	= GetListIDByUserID(index);
		
		if (player_index==-1)
		{
			player_index=AddToUserList(index);
			
			if (player_index==-1)
				goto Taktinen1;
		}
		
		pPlayer		= pEdict;

		RETURN_META(MRES_HANDLED);
	}

	RETURN_META(MRES_IGNORED);
}

player_weapon_t player_weapon;

void pfnWriteInt(int iValue)
{
	if (!gpGlobals->deathmatch || !capturemode) RETURN_META(MRES_IGNORED);
	
	player_t *player = &players[player_index];
	current_weapon_t *curwep = &players[player_index].current_weapon;

	if (cap_msg_type==message_CurWeapon)
	{
		static int iState;
		static int iId;
		static int iClip;
		
		switch (capturecounter)
		{
			case 0:
			{
				iState=iValue;
				break;
			}
			case 1:
			{
				if (AmmoDetectAsFlag)
				{
					int flagId=iValue;
					iId=0;
					while(flagId>1)
					{
						flagId/=2;
						iId++;
					}
				}
				else iId=iValue;
				//iId=(AmmoDetectAsFlag) ? flagId_2_sdkId(iValue) : iValue;
				break;
			}
			case 2:
			{
				iClip=iValue;
				
				if (iId <= 31)
				{
					player->player_weapons |= (1<<iId);  // set this weapon bit

					if (iState == 1)
					{
            					curwep->iId = iId;
            					curwep->iClip = iClip;

            					// update the ammo counts for this weapon...
            					curwep->iAmmo1 = player->m_rgAmmo[weapon_defs[iId].iAmmo1];
            					curwep->iAmmo2 = player->m_rgAmmo[weapon_defs[iId].iAmmo2];
         				}
				}
			}
		}
	}
	else if (cap_msg_type==message_AmmoX)
	{
		static int index;
		static int ammount;
		int ammo_index;
		
		switch (capturecounter)
		{
			case 0:
			{
				index=iValue;
				break;
			}
			case 1:
			{
				ammount=iValue;
				
				player->m_rgAmmo[index] = ammount;  // store it away

      				ammo_index = curwep->iId;

      				// update the ammo counts for this weapon...
      				curwep->iAmmo1 = player->m_rgAmmo[weapon_defs[ammo_index].iAmmo1];
      				curwep->iAmmo2 = player->m_rgAmmo[weapon_defs[ammo_index].iAmmo2];

				break;
			}
		}
	}
	else if (cap_msg_type==message_WeaponList)
	{	
		switch (capturecounter) 
		{
			/*case 0: //!!!!!!!!!!!!SEE WRITESTRING
			{
				break;
			}*/
			case 1:
			{
				player_weapon.iAmmo1=iValue;
				break;
			}
			case 2:
			{
				player_weapon.iAmmo1Max=iValue;
				break;
			}
			case 3:
			{
				player_weapon.iAmmo2=iValue;
				break;
			}
			case 4:
			{
				player_weapon.iAmmo2Max=iValue;
				break;
			}
			case 5:
			{
				player_weapon.iSlot=iValue;
				break;
			}
			case 6:
			{
				player_weapon.iPosition=iValue;
				break;
			}
			case 7:
			{
				if (AmmoDetectAsFlag)
				{
					int flagId=iValue;
					player_weapon.iId=0;
					while(flagId>1)
					{
						flagId/=2;
						player_weapon.iId++;
					}
				}
				else player_weapon.iId=iValue;
				//player_weapon.iId = (AmmoDetectAsFlag) ? flagId_2_sdkId(iValue) : iValue;
				break;
			}
			case 8:
			{
				player_weapon.iFlags=iValue;
				weapon_defs[player_weapon.iId] = player_weapon;
				break;
			}
		}
	}
	
	if (wrecoil_debug->value>1) ALERT(at_console," [%d] iValue:%d\n",capturecounter,iValue);

	capturecounter++;
	
	RETURN_META(MRES_HANDLED);
}

void pfnWriteString(const char *sz)
{
	if (!gpGlobals->deathmatch || !capturemode) RETURN_META(MRES_IGNORED);
	
	if (cap_msg_type==message_WeaponList && capturecounter==0)
	{
		if (wrecoil_debug->value>1) ALERT(at_console," [%d] iString:%s\n",capturecounter,sz);
		
		strcpy(player_weapon.szClassname,sz);
		
		capturecounter=1;
		
		RETURN_META(MRES_HANDLED);
	}
	
	RETURN_META(MRES_IGNORED);
}

void pfnMessageEnd(void)
{
	if (!gpGlobals->deathmatch || !capturemode) RETURN_META(MRES_IGNORED);

	if (wrecoil_debug->value>1) ALERT(at_console,"[END]\n");

	if (cap_msg_type==message_CurWeapon||cap_msg_type==message_AmmoX)
	{
		current_weapon_t *curwep = &players[player_index].current_weapon;
		current_weapon_t *prewep = &players[player_index].previous_weapon;

		if ((prewep->iId < 0) || (prewep->iId != curwep->iId)) goto JumpGate;
			
		if (AllWeaponsClipless || prewep->iClip<0) //iClip below 0 only if clipless weapon!
		{
			if (prewep->iAmmo1 > curwep->iAmmo1)
				MakeRecoil(curwep->iId,pPlayer,(prewep->iAmmo1 - curwep->iAmmo1),wrecoil_multiplier->value,1);
		}
		else					//Weapons with clip!
		{
			if (prewep->iClip > curwep->iClip)
				MakeRecoil(curwep->iId,pPlayer,(prewep->iClip - curwep->iClip),wrecoil_multiplier->value,1);
		}
		
		if (prewep->iAmmo2 > curwep->iAmmo2)	//Secondary Attack(?)
			MakeRecoil(curwep->iId,pPlayer,(prewep->iAmmo2 - curwep->iAmmo2),wrecoil_multiplier->value,2);

JumpGate:
		if (wrecoil_debug->value>1) ALERT(at_console,"  {Previous weapon info(playerid:%d)} Id:%d Clip:%d Ammo1:%d Ammo2:%d\n", player_index,prewep->iId,prewep->iClip,prewep->iAmmo1,prewep->iAmmo2);
		if (wrecoil_debug->value>0) ALERT(at_console,"  <[Current weapon info(playerid:%d)] Id:%d Clip:%d Ammo1:%d Ammo2:%d>\n",player_index,curwep->iId,curwep->iClip,curwep->iAmmo1,curwep->iAmmo2);
				
		*prewep=*curwep;
	}
	
	capturemode  	= FALSE;
	cap_msg_type 	= 0;
	capturecounter	= 0;
	pPlayer		= NULL;
	
	RETURN_META(MRES_HANDLED);
}


/*int pfnRegUserMsg_Post(const char *pszName, int iSize)
{
	if (!gpGlobals->deathmatch) 
	{
		RETURN_META_VALUE(MRES_IGNORED,0);
		return 0;
	}
	
	int msg = META_RESULT_ORIG_RET(int);
	
	if      (strcmp(pszName, "CurWeapon")  == 0) message_CurWeapon = msg;
	else if (strcmp(pszName, "AmmoX")      == 0) message_AmmoX     = msg;
	else if (strcmp(pszName, "WeaponList") == 0) message_WeaponList= msg;
	else RETURN_META_VALUE(MRES_IGNORED, 0);
				
	RETURN_META_VALUE(MRES_HANDLED, 0);
	return 0;
}*/


enginefuncs_t meta_engfuncs = {
	NULL,			// pfnPrecacheModel()
	NULL,			// pfnPrecacheSound()
	NULL,			// pfnSetModel()
	NULL,			// pfnModelIndex()
	NULL,			// pfnModelFrames()

	NULL,			// pfnSetSize()
	NULL,			// pfnChangeLevel()
	NULL,			// pfnGetSpawnParms()
	NULL,			// pfnSaveSpawnParms()

	NULL,			// pfnVecToYaw()
	NULL,			// pfnVecToAngles()
	NULL,			// pfnMoveToOrigin()
	NULL,			// pfnChangeYaw()
	NULL,			// pfnChangePitch()

	NULL,			// pfnFindEntityByString()
	NULL,			// pfnGetEntityIllum()
	NULL,			// pfnFindEntityInSphere()
	NULL,			// pfnFindClientInPVS()
	NULL,			// pfnEntitiesInPVS()

	NULL,			// pfnMakeVectors()
	NULL,			// pfnAngleVectors()

	NULL,			// pfnCreateEntity()
	NULL,			// pfnRemoveEntity()
	NULL,			// pfnCreateNamedEntity()

	NULL,			// pfnMakeStatic()
	NULL,			// pfnEntIsOnFloor()
	NULL,			// pfnDropToFloor()

	NULL,			// pfnWalkMove()
	NULL,			// pfnSetOrigin()

	NULL,			// pfnEmitSound()
	NULL,			// pfnEmitAmbientSound()

	NULL,			// pfnTraceLine()
	NULL,			// pfnTraceToss()
	NULL,			// pfnTraceMonsterHull()
	NULL,			// pfnTraceHull()
	NULL,			// pfnTraceModel()
	NULL,			// pfnTraceTexture()
	NULL,			// pfnTraceSphere()
	NULL,			// pfnGetAimVector()

	NULL,			// pfnServerCommand()
	NULL,			// pfnServerExecute()
	NULL,			// pfnClientCommand()

	NULL,			// pfnParticleEffect()
	NULL,			// pfnLightStyle()
	NULL,			// pfnDecalIndex()
	NULL,			// pfnPointContents()

	pfnMessageBegin,	// pfnMessageBegin()
	pfnMessageEnd,		// pfnMessageEnd()

	pfnWriteInt,		// pfnWriteByte()
	pfnWriteInt,		// pfnWriteChar()
	pfnWriteInt,		// pfnWriteShort()
	pfnWriteInt,		// pfnWriteLong()
	NULL,			// pfnWriteAngle()
	NULL,			// pfnWriteCoord()
	pfnWriteString,		// pfnWriteString()
	NULL,			// pfnWriteEntity()

	NULL,			// pfnCVarRegister()
	NULL,			// pfnCVarGetFloat()
	NULL,			// pfnCVarGetString()
	NULL,			// pfnCVarSetFloat()
	NULL,			// pfnCVarSetString()

	NULL,			// pfnAlertMessage()
	NULL,			// pfnEngineFprintf()

	NULL,			// pfnPvAllocEntPrivateData()
	NULL,			// pfnPvEntPrivateData()
	NULL,			// pfnFreeEntPrivateData()

	NULL,			// pfnSzFromIndex()
	NULL,			// pfnAllocString()

	NULL, 			// pfnGetVarsOfEnt()
	NULL,			// pfnPEntityOfEntOffset()
	NULL,			// pfnEntOffsetOfPEntity()
	NULL,			// pfnIndexOfEdict()
	NULL,			// pfnPEntityOfEntIndex()
	NULL,			// pfnFindEntityByVars()
	NULL,			// pfnGetModelPtr()

	NULL,			// pfnRegUserMsg()

	NULL,			// pfnAnimationAutomove()
	NULL,			// pfnGetBonePosition()

	NULL,			// pfnFunctionFromName()
	NULL,			// pfnNameForFunction()

	NULL,			// pfnClientPrintf()			//! JOHN: engine callbacks so game DLL can print messages to individual clients
	NULL,			// pfnServerPrint()

	NULL,			// pfnCmd_Args()	//! these 3 added 
	NULL,			// pfnCmd_Argv()	//! so game DLL can easily 
	NULL,			// pfnCmd_Argc()	//! access client 'cmd' strings

	NULL,			// pfnGetAttachment()

	NULL,			// pfnCRC32_Init()
	NULL,			// pfnCRC32_ProcessBuffer()
	NULL,			// pfnCRC32_ProcessByte()
	NULL,			// pfnCRC32_Final()

	NULL,			// pfnRandomLong()
	NULL,			// pfnRandomFloat()

	NULL,			// pfnSetView()
	NULL,			// pfnTime()
	NULL,			// pfnCrosshairAngle()

	NULL,			// pfnLoadFileForMe()
	NULL,			// pfnFreeFile()

	NULL,			// pfnEndSection()				//! trigger_endsection
	NULL,			// pfnCompareFileTime()
	NULL,			// pfnGetGameDir()
	NULL,			// pfnCvar_RegisterVariable()
	NULL,			// pfnFadeClientVolume()
	NULL,			// pfnSetClientMaxspeed()
	NULL,			// pfnCreateFakeClient() 		//! returns NULL if fake client can't be created
	NULL,			// pfnRunPlayerMove()
	NULL,			// pfnNumberOfEntities()

	NULL,			// pfnGetInfoKeyBuffer()		//! passing in NULL gets the serverinfo
	NULL,			// pfnInfoKeyValue()
	NULL,			// pfnSetKeyValue()
	NULL,			// pfnSetClientKeyValue()
	
	NULL,			// pfnIsMapValid()
	NULL,			// pfnStaticDecal()
	NULL,			// pfnPrecacheGeneric()
	NULL,			// pfnGetPlayerUserId()			//! returns the server assigned userid for this player.
	NULL,			// pfnBuildSoundMsg()
	NULL,			// pfnIsDedicatedServer()		//! is this a dedicated server?
	NULL,			// pfnCVarGetPointer()
	NULL,			// pfnGetPlayerWONId()			//! returns the server assigned WONid for this player.

	//! YWB 8/1/99 TFF Physics additions
	NULL,			// pfnInfo_RemoveKey()
	NULL,			// pfnGetPhysicsKeyValue()
	NULL,			// pfnSetPhysicsKeyValue()
	NULL,			// pfnGetPhysicsInfoString()
	NULL,			// pfnPrecacheEvent()
	NULL,			// pfnPlaybackEvent()

	NULL,			// pfnSetFatPVS()
	NULL,			// pfnSetFatPAS()

	NULL,			// pfnCheckVisibility()

	NULL,			// pfnDeltaSetField()
	NULL,			// pfnDeltaUnsetField()
	NULL,			// pfnDeltaAddEncoder()
	NULL,			// pfnGetCurrentPlayer()
	NULL,			// pfnCanSkipPlayer()
	NULL,			// pfnDeltaFindField()
	NULL,			// pfnDeltaSetFieldByIndex()
	NULL,			// pfnDeltaUnsetFieldByIndex()

	NULL,			// pfnSetGroupMask()

	NULL,			// pfnCreateInstancedBaseline()		// d'oh, CreateInstancedBaseline in dllapi too
	NULL,			// pfnCvar_DirectSet()

	NULL,			// pfnForceUnmodified()

	NULL,			// pfnGetPlayerStats()

	NULL,			// pfnAddServerCommand()
};

void PN_UTIL_LogPrintf( char *fmt, ... );

C_DLLEXPORT int GetEngineFunctions(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) 
{
	if(!pengfuncsFromEngine) {
		PN_UTIL_LogPrintf("%s: GetEngineFunctions called with null pengfuncsFromEngine", Plugin_info.logtag);
		return(FALSE);
	}
	else if(*interfaceVersion != ENGINE_INTERFACE_VERSION) {
		PN_UTIL_LogPrintf("%s: GetEngineFunctions version mismatch; requested=%d ours=%d", Plugin_info.logtag, *interfaceVersion, ENGINE_INTERFACE_VERSION);
		// Tell metamod what version we had, so it can figure out who is out of date.
		*interfaceVersion = ENGINE_INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pengfuncsFromEngine, &meta_engfuncs, sizeof(enginefuncs_t));
	return TRUE;
}

/*
enginefuncs_t meta_engfuncs_post = {
	NULL,			// pfnPrecacheModel()
	NULL,			// pfnPrecacheSound()
	NULL,			// pfnSetModel()
	NULL,			// pfnModelIndex()
	NULL,			// pfnModelFrames()

	NULL,			// pfnSetSize()
	NULL,			// pfnChangeLevel()
	NULL,			// pfnGetSpawnParms()
	NULL,			// pfnSaveSpawnParms()

	NULL,			// pfnVecToYaw()
	NULL,			// pfnVecToAngles()
	NULL,			// pfnMoveToOrigin()
	NULL,			// pfnChangeYaw()
	NULL,			// pfnChangePitch()

	NULL,			// pfnFindEntityByString()
	NULL,			// pfnGetEntityIllum()
	NULL,			// pfnFindEntityInSphere()
	NULL,			// pfnFindClientInPVS()
	NULL,			// pfnEntitiesInPVS()

	NULL,			// pfnMakeVectors()
	NULL,			// pfnAngleVectors()

	NULL,			// pfnCreateEntity()
	NULL,			// pfnRemoveEntity()
	NULL,			// pfnCreateNamedEntity()

	NULL,			// pfnMakeStatic()
	NULL,			// pfnEntIsOnFloor()
	NULL,			// pfnDropToFloor()

	NULL,			// pfnWalkMove()
	NULL,			// pfnSetOrigin()

	NULL,			// pfnEmitSound()
	NULL,			// pfnEmitAmbientSound()

	NULL,			// pfnTraceLine()
	NULL,			// pfnTraceToss()
	NULL,			// pfnTraceMonsterHull()
	NULL,			// pfnTraceHull()
	NULL,			// pfnTraceModel()
	NULL,			// pfnTraceTexture()
	NULL,			// pfnTraceSphere()
	NULL,			// pfnGetAimVector()

	NULL,			// pfnServerCommand()
	NULL,			// pfnServerExecute()
	NULL,			// pfnClientCommand()

	NULL,			// pfnParticleEffect()
	NULL,			// pfnLightStyle()
	NULL,			// pfnDecalIndex()
	NULL,			// pfnPointContents()

	NULL,			// pfnMessageBegin()
	NULL,			// pfnMessageEnd()

	NULL,			// pfnWriteByte()
	NULL,			// pfnWriteChar()
	NULL,			// pfnWriteShort()
	NULL,			// pfnWriteLong()
	NULL,			// pfnWriteAngle()
	NULL,			// pfnWriteCoord()
	NULL,			// pfnWriteString()
	NULL,			// pfnWriteEntity()

	NULL,			// pfnCVarRegister()
	NULL,			// pfnCVarGetFloat()
	NULL,			// pfnCVarGetString()
	NULL,			// pfnCVarSetFloat()
	NULL,			// pfnCVarSetString()

	NULL,			// pfnAlertMessage()
	NULL,			// pfnEngineFprintf()

	NULL,			// pfnPvAllocEntPrivateData()
	NULL,			// pfnPvEntPrivateData()
	NULL,			// pfnFreeEntPrivateData()

	NULL,			// pfnSzFromIndex()
	NULL,			// pfnAllocString()

	NULL, 			// pfnGetVarsOfEnt()
	NULL,			// pfnPEntityOfEntOffset()
	NULL,			// pfnEntOffsetOfPEntity()
	NULL,			// pfnIndexOfEdict()
	NULL,			// pfnPEntityOfEntIndex()
	NULL,			// pfnFindEntityByVars()
	NULL,			// pfnGetModelPtr()

	pfnRegUserMsg_Post,	// pfnRegUserMsg()

	NULL,			// pfnAnimationAutomove()
	NULL,			// pfnGetBonePosition()

	NULL,			// pfnFunctionFromName()
	NULL,			// pfnNameForFunction()

	NULL,			// pfnClientPrintf()			//! JOHN: engine callbacks so game DLL can print messages to individual clients
	NULL,			// pfnServerPrint()

	NULL,			// pfnCmd_Args()	//! these 3 added 
	NULL,			// pfnCmd_Argv()	//! so game DLL can easily 
	NULL,			// pfnCmd_Argc()	//! access client 'cmd' strings

	NULL,			// pfnGetAttachment()

	NULL,			// pfnCRC32_Init()
	NULL,			// pfnCRC32_ProcessBuffer()
	NULL,			// pfnCRC32_ProcessByte()
	NULL,			// pfnCRC32_Final()

	NULL,			// pfnRandomLong()
	NULL,			// pfnRandomFloat()

	NULL,			// pfnSetView()
	NULL,			// pfnTime()
	NULL,			// pfnCrosshairAngle()

	NULL,			// pfnLoadFileForMe()
	NULL,			// pfnFreeFile()

	NULL,			// pfnEndSection()				//! trigger_endsection
	NULL,			// pfnCompareFileTime()
	NULL,			// pfnGetGameDir()
	NULL,			// pfnCvar_RegisterVariable()
	NULL,			// pfnFadeClientVolume()
	NULL,			// pfnSetClientMaxspeed()
	NULL,			// pfnCreateFakeClient() 		//! returns NULL if fake client can't be created
	NULL,			// pfnRunPlayerMove()
	NULL,			// pfnNumberOfEntities()

	NULL,			// pfnGetInfoKeyBuffer()		//! passing in NULL gets the serverinfo
	NULL,			// pfnInfoKeyValue()
	NULL,			// pfnSetKeyValue()
	NULL,			// pfnSetClientKeyValue()

	NULL,			// pfnIsMapValid()
	NULL,			// pfnStaticDecal()
	NULL,			// pfnPrecacheGeneric()
	NULL, 			// pfnGetPlayerUserId()			//! returns the server assigned userid for this player.
	NULL,			// pfnBuildSoundMsg()
	NULL,			// pfnIsDedicatedServer()		//! is this a dedicated server?
	NULL,			// pfnCVarGetPointer()
	NULL,			// pfnGetPlayerWONId()			//! returns the server assigned WONid for this player.

	//! YWB 8/1/99 TFF Physics additions
	NULL,			// pfnInfo_RemoveKey()
	NULL,			// pfnGetPhysicsKeyValue()
	NULL,			// pfnSetPhysicsKeyValue()
	NULL,			// pfnGetPhysicsInfoString()
	NULL,			// pfnPrecacheEvent()
	NULL,			// pfnPlaybackEvent()

	NULL,			// pfnSetFatPVS()
	NULL,			// pfnSetFatPAS()

	NULL,			// pfnCheckVisibility()

	NULL,			// pfnDeltaSetField()
	NULL,			// pfnDeltaUnsetField()
	NULL,			// pfnDeltaAddEncoder()
	NULL,			// pfnGetCurrentPlayer()
	NULL,			// pfnCanSkipPlayer()
	NULL,			// pfnDeltaFindField()
	NULL,			// pfnDeltaSetFieldByIndex()
	NULL,			// pfnDeltaUnsetFieldByIndex()

	NULL,			// pfnSetGroupMask()

	NULL, 			// pfnCreateInstancedBaseline()		// d'oh, CreateInstancedBaseline in dllapi too
	NULL,			// pfnCvar_DirectSet()

	NULL,			// pfnForceUnmodified()

	NULL,			// pfnGetPlayerStats()

	NULL,			// pfnAddServerCommand()
};

C_DLLEXPORT int GetEngineFunctions_Post(enginefuncs_t *pengfuncsFromEngine, int *interfaceVersion ) 
{
	if(!pengfuncsFromEngine) {
		PN_UTIL_LogPrintf("%s: GetEngineFunctions called with null pengfuncsFromEngine", Plugin_info.logtag);
		return(FALSE);
	}
	else if(*interfaceVersion != ENGINE_INTERFACE_VERSION) {
		PN_UTIL_LogPrintf("%s: GetEngineFunctions version mismatch; requested=%d ours=%d", Plugin_info.logtag, *interfaceVersion, ENGINE_INTERFACE_VERSION);
		// Tell metamod what version we had, so it can figure out who is out of date.
		*interfaceVersion = ENGINE_INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pengfuncsFromEngine, &meta_engfuncs_post, sizeof(enginefuncs_t));
	return TRUE;
}*/

int DispatchSpawn( edict_t *pent )
{	
	if (!gpGlobals->deathmatch) 
	{
		RETURN_META_VALUE(MRES_IGNORED, 0);
		return 0;
	}
	
	char *pClassname = (char *)STRING(pent->v.classname);
	if (!stricmp(pClassname, "worldspawn"))
	{
		LoadINIData();
		
		memset(&players,0,sizeof(players));
		for (int i=0;i<32;i++) players[i].UserID=-1;
		
		RETURN_META_VALUE(MRES_HANDLED, 0);
   	}
	
	RETURN_META_VALUE(MRES_IGNORED, 0);
	return 0;
}

void ClientDisconnect( edict_t *pThis )
{
	if (!gpGlobals->deathmatch) RETURN_META(MRES_IGNORED);
	
	int listid;
	int userid=GETPLAYERUSERID(pThis);
	
	if (userid==-1) RETURN_META(MRES_IGNORED);
	
	listid = GetListIDByUserID( userid );
	
	if (listid==-1) RETURN_META(MRES_IGNORED);
	
	//HACK HACK! We have to set this on so UserID doesn't get add to list after disconnect!
	pThis->v.spawnflags|=(SF_PLAYER_DISCONNECTED1|SF_PLAYER_DISCONNECTED2);
	
	memset(&players[listid],0,sizeof(player_t));
	
	players[listid].UserID=-1;

	RETURN_META(MRES_HANDLED);
}

static DLL_FUNCTIONS gFunctionTable = 
{
	NULL,						//! pfnGameInit()
	DispatchSpawn,					//! pfnSpawn()
	NULL,						//! pfnThink()
	NULL,						//! pfnUse()
	NULL,						//! pfnTouch()
	NULL,						//! pfnBlocked()
	NULL,						//! pfnKeyValue()
	NULL,						//! pfnSave()
	NULL,						//! pfnRestore()
	NULL,						//! pfnSetAbsBox()

	NULL,						//! pfnSaveWriteFields()
	NULL,						//! pfnSaveReadFields()

	NULL,						//! pfnSaveGlobalState()
	NULL,						//! pfnRestoreGlobalState()
	NULL,						//! pfnResetGlobalState()

	NULL,						//! pfnClientConnect()
	ClientDisconnect,				//! pfnClientDisconnect()
	NULL,						//! pfnClientKill()
	NULL,						//! pfnClientPutInServer()
	NULL,						//! pfnClientCommand()
	NULL,						//! pfnClientUserInfoChanged()
	NULL,//ServerActivate,				//! pfnServerActivate()
	NULL,						//! pfnServerDeactivate()

	NULL,						//! pfnPlayerPreThink()
	NULL,						//! pfnPlayerPostThink()

	NULL,						//! pfnStartFrame()
	NULL,						//! pfnParmsNewLevel()
	NULL,						//! pfnParmsChangeLevel()

	NULL,						//! pfnGetGameDescription()
	NULL,						//! pfnPlayerCustomization()

	NULL,						//! pfnSpectatorConnect()
	NULL,						//! pfnSpectatorDisconnect()
	NULL,						//! pfnSpectatorThink()
	
	NULL,						//! pfnSys_Error()

	NULL,						//! pfnPM_Move()
	NULL,						//! pfnPM_Init()
	NULL,						//! pfnPM_FindTextureType()
	
	NULL,						//! pfnSetupVisibility()
	NULL,						//! pfnUpdateClientData()
	NULL,						//! pfnAddToFullPack()
	NULL,						//! pfnCreateBaseline()
	NULL,						//! pfnRegisterEncoders()
	NULL,						//! pfnGetWeaponData()
	NULL,						//! pfnCmdStart()
	NULL,						//! pfnCmdEnd()
	NULL,						//! pfnConnectionlessPacket()
	NULL,						//! pfnGetHullBounds()
	NULL,						//! pfnCreateInstancedBaselines()
	NULL,						//! pfnInconsistentFile()
	NULL,						//! pfnAllowLagCompensation()
};

C_DLLEXPORT int GetEntityAPI2( DLL_FUNCTIONS *pFunctionTable, int *interfaceVersion )
{
	LOG_DEVELOPER(PLID, "called: GetEntityAPI2; version=%d", *interfaceVersion);
	if(!pFunctionTable) {
		LOG_ERROR(PLID, "GetEntityAPI2 called with null pFunctionTable");
		return(FALSE);
	}
	else if(*interfaceVersion != INTERFACE_VERSION) {
		LOG_ERROR(PLID, "GetEntityAPI2 version mismatch; requested=%d ours=%d", *interfaceVersion, INTERFACE_VERSION);
		//! Tell engine what version we had, so it can figure out who is out of date.
		*interfaceVersion = INTERFACE_VERSION;
		return(FALSE);
	}
	memcpy(pFunctionTable, &gFunctionTable, sizeof(DLL_FUNCTIONS));
	return(TRUE);
}

