#include <extdll.h>
#include "sdk_util.h"
//#include "engine.h"
//#include <dllapi.h>
#include <meta_api.h>
//#include "vector.h"
#include "libini.h"

// weapon ID values for Half-life DM && Opfor DM/CTF
/*#define WEAPON_CROWBAR			1	//No recoil
#define WEAPON_GLOCK			2	
#define WEAPON_PYTHON		  	3	
#define WEAPON_MP5			4	
#define WEAPON_CHAINGUN			5	//No recoil
#define WEAPON_CROSSBOW			6	//No recoil
#define WEAPON_SHOTGUN		 	7	
#define WEAPON_RPG			8	
#define WEAPON_GAUSS			9	//No recoil
#define WEAPON_EGON			10	//No recoil
#define WEAPON_HORNETGUN	 	11	
#define WEAPON_HANDGRENADE  		12	//No recoil
#define WEAPON_TRIPMINE	  		13	//No recoil
#define WEAPON_SATCHEL			14	//No recoil
#define WEAPON_SNARK		  	15	//No recoil
#define WEAPON_GRAPPLE			16	//No recoil
#define WEAPON_EAGLE		  	17	
#define WEAPON_PIPEWRENCH		18	//No recoil
#define WEAPON_M249			19	
#define WEAPON_DISPLACER	 	20	//No recoil
#define WEAPON_UNKNOWN21	 	21	//No recoil
#define WEAPON_SHOCKRIFLE		22	//No recoil
#define WEAPON_SPORELAUNCHER 		23	
#define WEAPON_SNIPERRIFLE  		24	//No recoil
#define WEAPON_KNIFE		 	25	//No recoil

float ValveGearboxRecoilTable_forClipAndAmmo1[64] =
{
	0,	//NULLWEAPON!
	0,	//CROWBAR
	35,	//GLOCK
	80,	//PYTHON
	50,	//MP5
	0,	//CHAINGUN?!
	0,	//CROSSBOW
	175,	//SHOTGUN
	175,	//RPG
	0,	//GAUSS
	0,	//EGON
	80,	//HORNETGUN
	35,	//HANDGRENADE
	0,	//TRIPMINE
	50,	//SATCHEL
	35,	//SNARK
	0,	//GRAPPLE
	80,	//EAGLE
	0,	//PIPEWRENCH
	15,	//M249
	0,	//DISPLACER
	0,	//UNKNOWN21
	35,	//SHOCKRIFLE
	150,	//SPORELAUNCHER
	120,	//SNIPERRIFLE
	0,	//KNIFE
};

float ValveGearboxRecoilTable_forAmmo2[64] =
{
	0,
	0,	//CROWBAR
	0,	//GLOCK
	0,	//PYTHON
	150,	//MP5
	0,	//CHAINGUN?!
	0,	//CROSSBOW
	0,	//SHOTGUN
	0,	//RPG
	0,	//GAUSS
	0,	//EGON
	0,	//HORNETGUN
	0,	//HANDGRENADE
	0,	//TRIPMINE
	0,	//SATCHEL
	0,	//SNARK
	0,	//GRAPPLE
	0,	//EAGLE
	0,	//PIPEWRENCH
	0,	//M249
	0,	//DISPLACER
	0,	//UNKNOWN21
	0,	//SHOCKRIFLE
	0,	//SPORELAUNCHER
	0,	//SNIPERRIFLE
	0,	//KNIFE
};*/

extern float RecoilTableAmmo1[64];
extern float RecoilTableAmmo2[64];

extern int AmmoDetectAsFlag;
extern int AllWeaponsClipless;
extern char *mod_dir;

#ifdef __linux__
	#define itoa(integer,string,ignored) sprintf(string,"%d",integer)
#endif

void LoadINIData(void)
{
	char filename[256];
	int i,value;

	memset(&RecoilTableAmmo2,0,sizeof(RecoilTableAmmo2));
	memset(&RecoilTableAmmo1,0,sizeof(RecoilTableAmmo1));
	
	strcpy(filename,mod_dir);
	strcat(filename,
#ifdef __linux__
	"/" 
#else
	"\\"
#endif
	"wrecoil_mm.ini");

	ALERT(at_console,"[%s] Loading weapon recoil config from '%s' ... ", Plugin_info.logtag,filename);
	
	ini_fd_t inidata=ini_open(filename,"r",";");

	if (!inidata)
	{
		ALERT(at_console,"Failed!\n");
		
		return;
	}
	ALERT(at_console,"Successed!\n");
	
	char head_ammo1[256];
	char head_ammo2[256];

        if (
                !stricmp(mod_dir, "valve")
                        ||
                !stricmp(mod_dir, "hulludm")
                        ||
                !stricmp(mod_dir, "phineas")
                	||
                !stricmp(mod_dir, "gearbox")
           )
	{
		strcpy(head_ammo1,"standard(valve,gearbox,etc)");
		strcpy(head_ammo2,"standard(valve,gearbox,etc)");
	}
	else
	{
		strcpy(head_ammo1,mod_dir);
		strcpy(head_ammo2,mod_dir);
	}
	
	if (!ini_locateHeading(inidata,head_ammo1))
	{
		value=0;
		AmmoDetectAsFlag   = (!ini_locateKey(inidata,"AmmoIdIsFlag") && !ini_readInt(inidata,&value) && value!=0);
		value=0;
		AllWeaponsClipless = (!ini_locateKey(inidata,"AllWeaponsClipless") && !ini_readInt(inidata,&value) && value!=0);
	}
	else
	{
		AmmoDetectAsFlag=AllWeaponsClipless=FALSE;
	}
	
	strcat(head_ammo1,"-AMMO1");
	strcat(head_ammo2,"-AMMO2");
	
	if (!ini_locateHeading(inidata,head_ammo1))
	{
		for (i=0;i<64;i++) 
		{
			value=0;
			
			char num[5];

			itoa(i,num,10);

			if (!ini_locateKey(inidata,num) && !ini_readInt(inidata,&value) && value>0)
			   	RecoilTableAmmo1[i]=value;
		}
	}
	
	if (!ini_locateHeading(inidata,head_ammo2))
	{
		for (value=i=0;i<64;i++) 
		{
			value=0;
			
			char num[5];

			itoa(i,num,10);

			if (!ini_locateKey(inidata,num) && !ini_readInt(inidata,&value) && value>0)
			   	RecoilTableAmmo2[i]=value;
		}
	}
	
	ini_close(inidata);
}
